#include <stdio.h>
#include "neo.h"

void neo_aa_create(neo_aa *aa)
{
  neo_list_create(&(aa->keys));
  neo_list_create(&(aa->vals));
}

/* set the value associated with 'key' to be 'val'.
 */
void neo_aa_set(neo_aa *aa, char *key, char *val)
{
  int i, j;
  char *ele;
  neo_list *keys;

  keys=&(aa->keys);
  j=neo_list_get_size(keys);
  for (i=0; i<j; i++) {
    ele=neo_list_get_element(keys, i);
    if (!strcmp(key, ele)) {
      /* Found it.  Nuke the old one and replace */
      free(ele);
      neo_list_replace_element(&(aa->vals), i, strdup(val));
      return;
    }
  }

  /* Didn't find it, add a new key/value pair */

  neo_list_append_element(keys, strdup(key));
  neo_list_append_element(&(aa->vals), strdup(val));
  return;
}

/* Return the value associated with 'key'.  If no such
 * key is found, return NULL.
 */
char *neo_aa_get_val(neo_aa *aa, char *key)
{
  int i, j;

  j=neo_list_get_size(&(aa->keys));
  for (i=0; i<j; i++) {
    if (!strcmp(key, neo_list_get_element(&(aa->keys), i))) {
      return(neo_list_get_element(&(aa->vals), i));
    }
  }
  return(NULL);
}

void neo_aa_free(neo_aa *aa)
{
  neo_list_free_all(&(aa->keys), &free);
  neo_list_free_all(&(aa->vals), &free);
}
